grub_install: remove pre-jessie code
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/bash
2 # Filename:      grml-debootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via Grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see https://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2+
7 ################################################################################
8
9 # error_handler {{{
10 [ -n "$REPORT_TRAP_ERR" ] || REPORT_TRAP_ERR='no'
11 [ -n "$FAIL_TRAP_ERR" ] || FAIL_TRAP_ERR='no'
12
13 error_handler() {
14    last_exit_code="$?"
15    last_bash_command="$BASH_COMMAND"
16    if [ "$REPORT_TRAP_ERR" = "yes" ]; then
17       echo "Unexpected non-zero exit code $last_exit_code in ${BASH_SOURCE[*]} at line ${BASH_LINENO[*]} detected!
18 last bash command: $last_bash_command"
19    fi
20    if [ ! "$FAIL_TRAP_ERR" = "yes" ]; then
21       return
22    fi
23    ## Check if "bailout" function is available.
24    ## This is not the case in chroot-script.
25    if command -v bailout >/dev/null 2>&1; then
26       bailout 1
27    else
28       echo 'FAIL_TRAP_ERR is set to "yes", exit 1.'
29       exit 1
30    fi
31 }
32
33 if [ "$REPORT_TRAP_ERR" = "yes" ] || [ "$FAIL_TRAP_ERR" = "yes" ]; then
34    set -e
35    set -E
36    set -o pipefail
37    trap "error_handler" ERR
38    export -f "error_handler"
39 fi
40 # }}}
41
42 # variables {{{
43 PN="$(basename "$0")"
44 if [[ -d "$(dirname "$(command -v "$0")")"/.git ]]; then
45   VERSION="$(git --git-dir $(dirname "$(command -v "$0")")/.git describe | sed 's|^v||')"
46 else
47   VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
48 fi
49 VERSION="${VERSION:-unknown}"
50 MNTPOINT="/mnt/debootstrap.$$"
51
52 # defaults
53 [ -n "$CHROOT_SCRIPTS" ] || CHROOT_SCRIPTS='yes'
54 [ -n "$CONFFILES" ] || CONFFILES='/etc/debootstrap'
55 [ -n "$DEBCONF" ] || DEBCONF='yes'
56 [ -n "$DEBIAN_FRONTEND" ] || DEBIAN_FRONTEND='noninteractive'
57 [ -n "$DEBOOTSTRAP" ] || DEBOOTSTRAP='debootstrap'
58 [ -n "$DEFAULT_LANGUAGE" ] || DEFAULT_LANGUAGE='en_US:en'
59 [ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
60 [ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
61 [ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
62 [ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://deb.debian.org/debian'
63 [ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
64 [ -n "$FORCE" ] || FORCE=''
65 [ -n "$HOSTNAME" ] || HOSTNAME='grml'
66 [ -n "$INITRD" ] || INITRD='yes'
67 [ -n "$INITRD_GENERATOR" ] || INITRD_GENERATOR='initramfs-tools'
68 [ -n "$INITRD_GENERATOR_OPTS" ] || INITRD_GENERATOR_OPTS=''
69 [ -n "$INSTALL_NOTES" ] || INSTALL_NOTES='/etc/debootstrap/install_notes'
70 [ -n "$LOCALES" ] || LOCALES='yes'
71 [ -n "$MIRROR" ] || MIRROR="$FALLBACK_MIRROR"
72 [ -n "$MKFS" ] || MKFS='mkfs.ext4'
73 [ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
74 [ -n "$PACKAGES" ] || PACKAGES='yes'
75 [ -n "$POST_SCRIPTS" ] || POST_SCRIPTS='yes'
76 [ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
77 [ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
78 [ -n "$RELEASE" ] || RELEASE='bookworm'
79 [ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
80 [ -n "$SCRIPTS" ] || SCRIPTS='no' # deprecated, replaced by POST_SCRIPTS
81 [ -n "$SECURE" ] || SECURE='yes'
82 [ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
83 [ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
84 [ -n "$UPGRADE_SYSTEM" ] || UPGRADE_SYSTEM='yes'
85 [ -n "$VMSIZE" ] || VMSIZE="2G"
86 [ -n "$GRUB_INSTALL" ] || GRUB_INSTALL='yes'
87
88 # inside the chroot system locales might not be available, so use minimum:
89 export LANG=C
90 export LC_ALL=C
91 export LANGUAGE=C
92
93 # make sure interactive mode is only executed when
94 # using an empty configuration file or option --interactive
95 INTERACTIVE=''
96 # }}}
97
98 # help text {{{
99 usage() {
100   echo "$PN - wrapper around debootstrap for installing Debian
101
102 Usage: $PN [options]
103
104 Bootstrap options:
105
106   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
107   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
108                          instead of fetching packages from a mirror.
109   -r, --release <name>   Release of new Debian system (default: bullseye).
110   -t, --target <target>  Target partition (/dev/...) or directory where the
111                          system should be installed to.
112   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
113                          has no effect if -t is given and represents a directory.
114       --debopt <params>  Extra parameters passed to the debootstrap command.
115       --interactive      Use interactive mode (frontend).
116       --nodebootstrap    Skip debootstrap, only do configuration to the target.
117       --grub <device>    Target for grub installation. Usage example: /dev/sda
118       --efi <device>     Target for EFI installation. Usage example: /dev/sda1
119       --arch <arch>      Set target architecture, use for installing i386 on amd64.
120       --filesystem <fs>  Filesystem that should be used when target is a partition
121                          or Virtual Machine (see --vmfile).
122       --force            Do not prompt for user acknowledgement.
123
124 Options for Virtual Machine deployment:
125
126       --vm               Set up a Virtual Machine on an existing block device
127                          instead of plainly installing to a partition or
128                          directory. Needs to be combined with --target.
129                          Example: --vm --target /dev/mapper/your-vm-disk
130       --vmfile           Like --vm, but install into a regular file (created by
131                          'qemu-img create -f raw ...') instead.
132                          Example: --vmfile --target /mnt/sda1/qemu.img
133       --vmsize <size>    Use specified size for size of VM file (default: 2G).
134                          Syntax as supported by qemu-img, like: --vmsize 3G
135       --vmefi            Create an EFI boot partition for the VM.
136
137 Configuration options:
138
139   -c, --config <file>      Use specified configuration file, defaults to
140                              /etc/debootstrap/config
141   -d, --confdir <path>     Place of config files for debootstrap, defaults
142                              to /etc/debootstrap
143       --packages <file>    Install packages defined in specified list file
144                              instead of using /etc/debootstrap/packages.
145       --nopackages         Skip installation of packages defined in
146                              /etc/debootstrap/packages
147       --nokernel           Skip installation of default kernel images.
148       --nointerfaces       Do not copy /etc/network/interfaces from host system
149                            to target system.
150                            (This option is automatically enabled when using --vmfile.)
151       --defaultinterfaces  Install a default /etc/network/interfaces file (enabling
152                            DHCP for eth0) instead of taking over config from host system.
153       --debconf <file>     Pre-seed packages using specified pre-seed db file.
154       --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
155       --backportrepos      Enable Debian's backports repository (backports.debian.org).
156       --keep_src_list      Do not overwrite user provided apt sources.list.
157       --contrib            Enable 'contrib' in COMPONENTS (defaults to 'main' only).
158       --non-free           Enable non-free / non-free-firmware in COMPONENTS (defaults to 'main' only).
159       --hostname <name>    Hostname of Debian system.
160       --nopassword         Do not prompt for the root password.
161       --password <pwd>     Use specified password as password for user root.
162       --sshcopyauth        Use ${HOME}/.ssh/authorized_keys to authorise root login on the target system.
163       --sshcopyid          Use locally available public keys to authorise root login on the target system.
164       --bootappend <line>  Add specified appendline to kernel whilst booting.
165       --chroot-scripts <d> Execute chroot scripts from specified directory.
166       --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
167       --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
168       --remove-configs     Delete grml-debootstrap configuration files from installed system.
169
170 Other options:
171
172   -v, --verbose            Increase verbosity.
173       --debug              Execute in very verbose way.
174   -h, --help               Print this usage information and exit.
175   -V, --version            Show summary of options and exit.
176
177 Usage examples can be found in the grml-debootstrap manpage.
178 Send bugreports to the grml-team: bugs (at) grml.org || https://grml.org/bugs/
179 "
180 }
181
182 if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
183    usage
184    echo 'Please notice that this script requires root permissions!'
185    exit 0
186 fi
187 # }}}
188
189 # early helper functions {{{
190 # skip colors when running within a dumb terminal
191 if [ "${TERM}" = "dumb" ] ; then
192   GOOD=
193   BAD=
194   WARN=
195   NORMAL=
196 else
197   GOOD='\e[32;01m'
198   BAD='\e[31;01m'
199   WARN='\e[33;01m'
200   NORMAL='\e[0m'
201 fi
202
203 einfo() {
204   einfon "$1\\n"
205   return 0
206 }
207
208 einfon() {
209   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
210   printf " %s*%s $*" "${GOOD}" "${NORMAL}"
211   LAST_E_CMD=einfon
212   return 0
213 }
214
215 ewarn() {
216   printf " %s*%s $*\\n" "${WARN}" "${NORMAL}"
217   return 0
218 }
219
220 eerror() {
221   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
222   printf " %s*%s $*\\n" "${BAD}" "${NORMAL}" >&2
223   LAST_E_CMD=eerror
224   return 0
225 }
226
227 eend() {
228   local retval="${1:-0}"
229   shift
230   if [ "$retval" -gt 0 ]; then
231     printf " %s-> Failed (rc=%s)%s\\n" "${BAD}" "${retval}" "${NORMAL}"
232   fi
233   return "$retval"
234 }
235
236 check4root(){
237   if [ "$(id -u 2>/dev/null)" != 0 ] ; then
238     echo 1>&2 "Error: please run this script with uid 0 (root)." ; return 1
239   fi
240 }
241
242 check4progs(){
243   local RC=''
244   for arg in "$@" ; do
245     command -v "$arg" >/dev/null 2>&1 || RC="$arg"
246   done
247   if [ -n "$RC" ] ; then
248      echo "$RC not installed"
249      return 1
250   fi
251 }
252 # }}}
253
254 # helper functions {{{
255 cleanup() {
256   if [ -n "$CHROOT_VARIABLES" ] ; then
257     einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
258   fi
259
260   if [ -n "$STAGES" ] ; then
261     einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
262   fi
263
264   if [ -n "$ARM_EFI_TARGET" ]; then
265     umount "${MNTPOINT}/boot/efi" >/dev/null 2>&1
266   fi
267
268   # Remove temporary mountpoint again
269   if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
270     rmdir "$MNTPOINT" 2>/dev/null
271   fi
272
273   # make sure $TARGET is not mounted when exiting grml-debootstrap
274   if [ -n "$MNTPOINT" ] ; then
275     if grep -q "$MNTPOINT" /proc/mounts ; then
276       # make sure nothing is left inside chroot so we can unmount it
277       for service in ssh mdadm ; do
278         if [ -x "${MNTPOINT}/etc/init.d/${service}" ] ; then
279           chroot "$MNTPOINT" "/etc/init.d/${service}" stop
280         fi
281       done
282
283       [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
284
285       # ugly, but make sure we really don't leave anything (/proc /proc and
286       # /dev /dev are intended, trying to work around timing issues, see #657023)
287       for ARG in /run/udev /sys /proc /proc /dev/pts /dev/pts /dev /dev ; do
288         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
289         umount "$MNTPOINT"/$ARG >/dev/null 2>&1
290       done
291
292       if [ -n "$ISODIR" ] ; then
293         [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
294       fi
295
296       if [ -n "$DIRECTORY" ] ; then
297         einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice."
298       else
299         einfo "Unmounting $MNTPOINT"
300         umount "$MNTPOINT"
301         eend $?
302       fi
303
304       if [ -n "$STAGES" ] ; then
305         echo -n "Removing stages directory ${STAGES}: "
306         rm -rf "$STAGES" && echo 'done'
307       fi
308
309       # remove directory only if we used the default with process id inside the name
310       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
311         einfo "Removing directory ${MNTPOINT}"
312         rmdir "$MNTPOINT"
313         eend $?
314       fi
315     fi
316   fi
317
318   if [ -n "${ORIG_TARGET}" ] ; then
319     einfo "Removing loopback mount of file ${ORIG_TARGET}."
320     kpartx -d "${ORIG_TARGET}"
321     # Workaround for a bug in kpartx which doesn't clean up properly,
322     # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
323     if dmsetup ls | grep -q "^${LOOP_PART} "; then
324       kpartx -d "/dev/${LOOP_DISK}" >/dev/null
325     fi
326     eend $?
327   fi
328 }
329
330 # we want to exit smoothly and clean:
331 bailout(){
332
333   cleanup
334
335   [ -n "$1" ] && EXIT="$1" || EXIT="1"
336   [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
337
338   exit "$EXIT"
339 }
340 trap bailout HUP INT QUIT TERM
341
342 # we want to execute all the functions only once, simple check for it:
343 stage() {
344   if [ -n "$2" ] ; then
345      echo "$2" > "${STAGES}/${1}"
346      return 0
347   elif grep -q 'done' "${STAGES}/${1}" 2>/dev/null ; then
348      ewarn "Notice: stage $1 has been executed already, skipping execution therefore."
349      ewarn "  To reexecute it clean up the according directory inside $STAGES"
350      return 1
351   fi
352 }
353 # }}}
354
355 # source main configuration file {{{
356 if [ -r /etc/debootstrap/config ] ; then
357   # shellcheck disable=SC1091
358   . /etc/debootstrap/config
359 fi
360 # }}}
361
362 # cmdline handling {{{
363 CMDLINE_OPTS=mirror:,iso:,release:,target:,mntpoint:,debopt:,defaultinterfaces,interactive,nodebootstrap,nointerfaces,nokernel,nopackages,filesystem:,config:,confdir:,packages:,chroot-scripts:,scripts:,post-scripts:,pre-scripts:,debconf:,vm,vmfile,vmsize:,vmefi,keep_src_list,hostname:,password:,nopassword,grmlrepos,backportrepos,bootappend:,grub:,efi:,arch:,insecure,verbose,help,version,force,debug,contrib,non-free,remove-configs,sshcopyid,sshcopyauth
364
365 _opt_temp=$(getopt --name grml-debootstrap -o +m:i:r:t:p:c:d:vhV --long \
366   $CMDLINE_OPTS -- "$@")
367
368 if [ $? != 0 ]; then
369   eerror "Try 'grml-debootstrap --help' for more information."; eend 1; exit 1
370 fi
371 eval set -- "$_opt_temp"
372
373 while :; do
374   case "$1" in
375
376   # == Bootstrap options
377   --mirror|-m)         # Mirror which should be used for apt-get/aptitude
378     shift; _opt_mirror="$1"
379     ;;
380   --iso|-i)            # Mountpoint where a Debian ISO is mounted to
381     shift; _opt_iso="$1"
382     ;;
383   --release|-r)        # Release of new Debian system
384     shift; _opt_release="$1"
385     ;;
386   --target|-t)         # Target partition (/dev/...) or directory
387     shift; _opt_target="$1"
388     ;;
389   --vm)                # Virtual machine image (no file)
390     _opt_vm="T"
391     ;;
392   --vmfile)            # Virtual machine file
393     _opt_vmfile="T"
394     ;;
395   --vmsize)            # size of Virtual machine file
396     shift; _opt_vmsize="$1"
397     ;;
398   --vmefi)            # Create an EFI boot partition for the VM
399     _opt_vmefi="T"
400     ;;
401   --mntpoint|-p)       # Mountpoint used for mounting the target system
402     shift; _opt_mntpoint="$1"
403     ;;
404   --debopt)            # Extra parameters passed to the debootstrap command
405     shift; _opt_debopt="$1"
406     ;;
407   --filesystem)        # Filesystem that should be used
408     shift; _opt_filesystem="$1" ; FILESYSTEM="${_opt_filesystem}"
409     ;;
410   --interactive)       # Use interactive mode (frontend)
411     _opt_interactive=T
412     ;;
413   --nodebootstrap)     # Skip debootstrap, only do configuration to the target
414     _opt_nodebootstrap=T
415     ;;
416   --nopackages)        # Skip installation of packages defined in /etc/debootstrap/packages
417     _opt_nopackages=T
418     ;;
419   --arch)              # Target architecutre
420     shift; _opt_arch="$1"
421     ;;
422   # just for backwards compatibility
423   --insecure)
424     _opt_insecure=T
425     ;;
426   #
427
428   # == Configuration options
429   --config|-c)         # Use specified configuration file, defaults to /etc/debootstrap
430     shift; _opt_config="$1"
431     ;;
432   --confdir|-d)        # Place of config files for debootstrap, defaults to /etc/debootstrap
433     shift; _opt_confdir="$1"
434     ;;
435   --packages)          # Install packages defined in specified file
436     shift; _opt_packages="$1"
437     _opt_packages_set=T
438     ;;
439   --debconf)           # Pre-seed packages using specified file
440     shift; _opt_debconf="$1"
441     _opt_debconf_set=T
442     ;;
443   --pre-scripts)       # Execute scripts from specified directory (before chroot-scripts).
444     shift; _opt_pre_scripts="$1"
445     _opt_pre_scripts_set=T
446     ;;
447   --scripts)           # Execute scripts from specified directory [NOTE: deprecated, replaced via --post-scripts]
448     shift; _opt_scripts="$1"
449     _opt_scripts_set=T
450     ;;
451   --post-scripts)       # Execute scripts from specified directory
452     shift; _opt_post_scripts="$1"
453     _opt_post_scripts_set=T
454     ;;
455   --chroot-scripts)   # Execute chroot scripts from specified directory
456     shift; _opt_chroot_scripts="$1"
457     _opt_chroot_scripts_set=T
458     ;;
459   --keep_src_list)     # Do not overwrite user provided apt sources.list
460     _opt_keep_src_list=T
461     ;;
462   --hostname)          # Hostname of Debian system
463     shift; _opt_hostname="$1"
464     ;;
465   --password)          # Use specified password as password for user root
466     shift; _opt_password="$1"
467     ;;
468   --defaultinterfaces) # Install default /etc/network/interfaces
469     _opt_defaultinterfaces=T
470     ;;
471   --nointerfaces)      # Skip installation of /etc/network/interfaces
472     _opt_nointerfaces=T
473     ;;
474   --nokernel)          # Skip installation of default kernel images
475     _opt_nokernel=T
476     ;;
477   --nopassword)        # Skip password dialog
478     _opt_nopassword=T
479     ;;
480   --sshcopyid)         # Use locally available public keys to authorise root login on the target system
481     _opt_sshcopyid=T
482     ;;
483   --sshcopyauth)       # Use .ssh/authorized_keys to authorise root login on the target system
484     _opt_sshcopyauth=T
485     ;;
486   --grmlrepos)         # Enable Grml repository
487     _opt_grmlrepos=T
488     ;;
489   --backportrepos)     # Enable Debian backports repository
490     _opt_backportrepos=T
491     ;;
492   --bootappend)        # Add specified appendline to kernel whilst booting
493     shift; _opt_bootappend="$1"
494     ;;
495   --grub)              # Target for grub installation. Use grub syntax for specifying
496     shift; _opt_grub="$1"
497     ;;
498   --efi)               # Target for EFI boot installation
499     shift; _opt_efi="$1"
500     ;;
501   --contrib)           # Add 'contrib' to list of components
502     _opt_contrib=T
503     ;;
504   --non-free)          # Add 'non-free' to list of components
505     _opt_non_free=T
506     ;;
507   --remove-configs)    # Drop config files from installed system
508     _opt_remove_configs=T
509     ;;
510
511   # == Other options
512   --verbose|-v)        # Increase verbosity
513     if [ "$_opt_verbose" ]; then
514       _opt_verbose=$( _opt_verbose + 1 )
515     else
516       _opt_verbose=1
517     fi
518     ;;
519   --debug)             # Execute in debug mode
520     _opt_debug=T
521     ;;
522   --help|-h)           # Print usage information and exit
523     _opt_help=T
524     ;;
525   --version|-V)        # Show version information and exit
526     _opt_version=T
527     ;;
528   --force)             # Do not prompt for user input
529     _opt_force=T
530     ;;
531   --)
532     shift; break
533     ;;
534   *)
535     eerror "Internal getopt error!"; eend 1 ; exit 1
536     ;;
537   esac
538   shift
539 done
540
541 # == business-logic of command line parameter-processing
542
543 # source configuration file in <confdir> if supplied. {{{
544 [ "$_opt_confdir" ] && {
545   CONFFILES=$_opt_confdir
546   einfo "Using config files under $CONFFILES/."
547   if ! [ -r "$CONFFILES/config" ] ; then
548     eerror "Error: config file $CONFFILES/config not found."; eend 1; bailout 1
549   fi
550   # shellcheck disable=SC1091 source=config
551   if ! . "$CONFFILES/config" ; then
552     eerror "Error reading config file $CONFFILES/config" ; eend 1 ; bailout 1
553   fi
554   # restore the command line parameter value
555   CONFFILES=$_opt_confdir
556 }
557 # }}}
558
559 [ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
560 [ "$_opt_iso" ]                 && ISO=$_opt_iso
561 [ "$_opt_release" ]             && RELEASE=$_opt_release
562 [ "$_opt_target" ]              && TARGET=$_opt_target
563 [ "$_opt_vm" ]                  && VIRTUAL=1
564 [ "$_opt_vmfile" ]              && VMFILE=1 && VIRTUAL=1
565 [ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
566 [ "$_opt_vmefi" ]               && VMEFI=1
567 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
568 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
569 [ "$_opt_interactive" ]         && INTERACTIVE=1
570 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
571 [ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
572 [ "$_opt_packages_set" ]        && PACKAGES='yes'
573 [ "$_opt_nopackages" ]          && PACKAGES=''
574 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
575 [ "$_opt_post_scripts_set" ]    && POST_SCRIPTS='yes'
576 [ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
577 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
578 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
579 [ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
580 [ "$_opt_backportrepos" ]       && BACKPORTREPOS='yes'
581 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
582 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
583 [ "$_opt_nopassword" ]          && NOPASSWORD='yes'
584 [ "$_opt_defaultinterfaces" ]   && USE_DEFAULT_INTERFACES="true"
585 [ "$_opt_nointerfaces" ]        && NOINTERFACES="true"
586 [ "$_opt_nokernel" ]            && NOKERNEL="true"
587 [ "$_opt_sshcopyid" ]           && SSHCOPYID="true"
588 [ "$_opt_sshcopyauth" ]         && SSHCOPYAUTH="true"
589 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
590 [ "$_opt_grub" ]                && GRUB=$_opt_grub
591 [ "$_opt_efi" ]                 && EFI=$_opt_efi
592 [ "$_opt_arch" ]                && ARCH=$_opt_arch
593 [ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
594 [ "$_opt_force" ]               && FORCE=$_opt_force
595 [ "$_opt_verbose" ]             && VERBOSE="-v"
596 [ "$_opt_debug" ]               && DEBUG="true"
597 [ "$_opt_remove_configs" ]      && REMOVE_CONFIGS="yes"
598
599 # make sure main is always included
600 [ -z "$COMPONENTS" ]            && COMPONENTS="main"
601 [ "$_opt_contrib" ]             && COMPONENTS="$COMPONENTS contrib"
602
603 case "${RELEASE}" in
604   lenny|squeeze|wheezy|jessie|stretch|buster|bullseye)
605     [ "$_opt_non_free" ] && COMPONENTS="$COMPONENTS non-free"
606     ;;
607   *)
608     [ "$_opt_non_free" ] && COMPONENTS="$COMPONENTS non-free-firmware non-free"
609     ;;
610 esac
611
612 # command line option checks
613 if [ "$_opt_scripts_set" ] ; then
614   ewarn "Deprecation NOTE: --scripts option is deprecated, please switch to --post-scripts instead."
615   SCRIPTS='yes' # deprecated since grml-debootstrap >=0.71
616 fi
617
618 if [ "$_opt_grub" ] && [ "$_opt_vmfile" ] ; then
619   eerror "The --grub option is incompatible with --vmfile, please drop it from your command line."
620   eerror "The --grub option is unneeded as GRUB will be installed automatically (unless GRUB_INSTALL='no')."
621   eend 1
622   bailout 1
623 fi
624
625 if [ "${_opt_sshcopyid}" ] && [ "${_opt_sshcopyauth}" ] ; then
626   eerror "The --sshcopyid option is incompatible with --sshcopyauth, please drop either of them from your command line."
627   eend 1
628   bailout 1
629 fi
630
631 if [ -n "$ISO" ] && [[ "$DEBOOTSTRAP" =~ mmdebstrap$ ]] ; then
632   eerror "The ISO option is incompatible with usage of mmdebstrap for bootstrapping."
633   eerror "Either drop the --iso ... option or use plain debootstrap instead."
634   eend 1
635   bailout 1
636 fi
637
638 if [ "$DEBUG" = "true" ] ; then
639   set -x
640 fi
641
642 [ "$_opt_help" ] && {
643   usage
644   exit 0
645 }
646
647 [ "$_opt_version" ] && {
648   einfo "$PN - version $VERSION"
649   einfo "Report bugs via https://github.com/grml/grml-debootstrap/ or https://grml.org/bugs/"
650   exit 0
651 }
652 # }}}
653
654 # check for root permissions {{{
655 if ! check4root ; then
656    echo "For usage instructions please execute '$PN --help'."
657    bailout 1
658 fi
659 # }}}
660
661 # make sure we have what we need {{{
662 check4progs "${DEBOOTSTRAP}" || bailout 1
663
664 if [ -n "$VIRTUAL" ] ; then
665   check4progs kpartx parted qemu-img || bailout 1
666 fi
667 # }}}
668
669 # source specified configuration file {{{
670 if [ -n "$CONFIGFILE" ] ; then
671   einfo "Reading specified config file $CONFIGFILE."
672   # shellcheck disable=SC1091 source=config
673   if ! . "$CONFIGFILE" ; then
674     eerror "Error reading config file $CONFIGFILE" ; eend 1 ; bailout 1
675   fi
676 fi
677 # }}}
678
679 # backwards compatibility checks {{{
680 if [ -n "$GROOT" ] ; then
681    eerror "Error: you seem to have \$GROOT configured."
682    eerror "This variable is no longer supported, please visit the"
683    eerror "grml-debootstrap documentation for details."
684    eend 1
685    bailout 1
686 fi
687
688 if echo "$GRUB" | grep -q '^hd' ; then
689    eerror "Error: this syntax for the grub configuration variable is no longer supported."
690    eerror "Please do not use hd... any longer but /dev/sdX instead."
691    eend 1
692    bailout 1
693 fi
694 # }}}
695
696 # welcome screen {{{
697 welcome_dialog()
698 {
699    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
700 Do you want to continue installing Debian using this frontend?" 0 0 || bailout 0
701 }
702 # }}}
703
704 # ask for target {{{
705 prompt_for_target()
706 {
707   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
708                sed 's/*//' | \
709                grep -v 'Extended$' | \
710                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md[0-9]* 2>/dev/null || true);
711
712   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
713      dialog --title "$PN" --trim \
714      --msgbox "Sorry, no partitions found. Please configure your
715      harddisks (see /proc/partitions) using a tool like fdisk,
716      cfdisk, gpart, gparted,..." 0 0
717      bailout 1
718   fi
719
720   PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
721                      fs="$(blkid -s TYPE -o value "$i" 2>/dev/null)"
722                      [ -n "$fs" ] || fs='[no_filesystem_yet]'
723                      echo "$i" "$fs"
724                      unset fs
725                    done)
726
727   # shellcheck disable=SC2086
728   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
729          --menu "Please select the target partition:" 0 0 0 \
730          $PARTITION_LIST)
731   [ $? -eq 0 ] || bailout 1
732 }
733 # }}}
734
735 # ask for bootmanager {{{
736 prompt_for_bootmanager()
737 {
738   ADDITIONAL_PARAMS=""
739
740   if echo "$TARGET" | grep -q "/dev/md" ; then
741      MBRPART="all disks of Software RAID $TARGET"
742   else
743      # figure out whole disk device
744      found=
745      for device in /dev/disk/by-id/*
746      do
747         [ "$(readlink -f "$device")" = "${TARGET}" ] || continue
748         found=1
749         break
750      done
751      # shellcheck disable=SC2001
752      [ -n "$found" ] && MBRDISK=$(echo "${device}" | sed -e 's/-part[0-9][0-9]*$//')
753      if [ -e "$MBRDISK" ]; then
754         MBRDISK=$(readlink -f "$MBRDISK")
755      else
756         # fall back to old behaviour
757         # shellcheck disable=SC2001
758         MBRDISK=$(echo "${TARGET}" | sed -e 's/[0-9][0-9]*$//')
759      fi
760
761      MBRPART="MBR of $MBRDISK"
762   fi
763
764   for device in cciss/c0d0 sda hda; do
765     if [ "/dev/$device" != "${MBRDISK}" ]; then
766       grep -q $device /proc/partitions && \
767       ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
768     fi
769   done
770   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
771
772   OIFS="$IFS"; IFS=:
773
774   # shellcheck disable=SC2086
775   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
776           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
777             mbr       "install bootmanager into $MBRPART" \
778             nowhere   "do not install bootmanager at all" \
779           ${ADDITIONAL_PARAMS})
780   [ $? -eq 0 ] || bailout 3
781   IFS="$OIFS"
782
783   case "$GETMBR" in
784     mbr)
785       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
786       if echo "$TARGET" | grep -q "/dev/md" ; then
787         GRUB="$TARGET"
788       else
789         GRUB="$MBRDISK"
790       fi
791       ;;
792     hda)
793       GRUB="/dev/hda"
794       ;;
795     sda)
796       GRUB="/dev/sda"
797       ;;
798     nowhere)
799       GRUB=''
800       ;;
801   esac
802 }
803 # }}}
804
805 # ask for Debian release {{{
806 prompt_for_release()
807 {
808   [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='bullseye'
809   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
810             "Please enter the Debian release you would like to use for installation:" \
811             0 50 8 \
812             buster   Debian/10 \
813             bullseye Debian/11 \
814             bookworm Debian/12 \
815             sid      Debian/unstable)"
816   [ $? -eq 0 ] || bailout
817 }
818 # }}}
819
820 # ask for hostname {{{
821 prompt_for_hostname()
822 {
823   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
824             "Please enter the hostname you would like to use for installation:" \
825             0 0 "$HOSTNAME")"
826   [ $? -eq 0 ] || bailout
827 }
828 # }}}
829
830 # ask for password {{{
831 prompt_for_password()
832 {
833   if [ "$_opt_nopassword" ] ; then
834     einfo "Skip asking for root password as requested."
835     return 0
836   fi
837
838   ROOTPW1='PW1'
839   ROOTPW2='PW2'
840   while [ "$ROOTPW1" != "$ROOTPW2" ]; do
841     ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
842     "Please enter the password for the root account:" 10 60)
843     [ $? -eq 0 ] || bailout
844
845     ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
846     "Please enter the password for the root account again for \
847     confirmation:" 10 60)
848     [ $? -eq 0 ] || bailout
849
850     if [ "$ROOTPW1" != "$ROOTPW2" ]; then
851       dialog --stdout --title "${PN}" --ok-label \
852         "Retry" --msgbox "Passwords do not match!" 10 60
853     fi
854   done
855   ROOTPASSWORD="$ROOTPW1"
856 }
857 # }}}
858
859 # ask for Debian mirror {{{
860 prompt_for_mirror()
861 {
862   [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
863
864   CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
865           --menu "Where do you want to install from?" 0 0 0 \
866             net   "install via network (downloading from mirror)" \
867             local "install from local directory/mirror"
868           )
869   [ $? -eq 0 ] || bailout
870
871   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
872      [ -n "$MIRROR" ] || MIRROR='http://deb.debian.org/debian'
873      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
874                "Please enter Debian mirror you would like to use for installing packages." \
875                0 0 $MIRROR)"
876      [ $? -eq 0 ] || bailout
877   else # CHOOSE_MIRROR == local
878      [ -n "$ISO" ] || ISO='/mnt/mirror'
879      ISO="$(dialog --stdout --title "${PN}" --inputbox \
880                "Please enter directory name you would like to use for installing packages." \
881                0 0 $ISO)"
882      [ $? -eq 0 ] || bailout
883   fi
884 }
885 # }}}
886
887 # software raid setup {{{
888 config_swraid_setup()
889 {
890 TMPFILE=$(mktemp)
891
892 # Currently we support only raid1:
893 RAIDLEVEL='raid1'
894
895 MD_LIST=$(for i in $(seq 0 9) ; do
896             awk '{print $4}' /proc/partitions | grep -q "md$i" || \
897             echo "/dev/md$i /dev/md$i"
898           done)
899
900 # shellcheck disable=SC2086
901 TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
902 --menu "Which device do you want to use for ${RAIDLEVEL}?
903
904 Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
905 $MD_LIST)
906 [ $? -eq 0 ] || bailout 20
907
908 AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
909              sed 's/*//' | \
910              grep -v 'Extended$' | \
911              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
912 [ -n "$AVAILABLE_PARTITIONS" ] || echo "Fatal error: no partitions available?"
913 PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
914                      echo "$i $(blkid -s TYPE -o value "$i" 2>/dev/null || echo '[no_filesystem_yet]') off"
915                  done)
916
917 # shellcheck disable=SC2086
918 dialog --title "$PN" --separate-output \
919        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
920        $PARTITION_LIST 2>"$TMPFILE"
921 [ $? -eq 0 ] || bailout
922 SELECTED_PARTITIONS="$(cat "$TMPFILE")"
923
924 NUM_PARTITIONS=0
925 while IFS= read -r i; do
926   NUM_PARTITIONS=$(( NUM_PARTITIONS + 1 ))
927 done < "$TMPFILE"
928
929 # force metadata version 0.90 for lenny so old grub can boot from this array.
930 METADATA_VERSION=""
931 if [ "$RELEASE" = "lenny" ]; then
932    METADATA_VERSION="-e0"
933 fi
934
935 ERRORFILE=$(mktemp)
936 # shellcheck disable=SC2086
937 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
938       --raid-devices="${NUM_PARTITIONS}" ${METADATA_VERSION} ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE
939 RC=$?
940 if [ "$RC" = 0 ] ; then
941    dialog --title "$PN" --msgbox \
942    "Creating $TARGET was successful." 0 0
943    rm -f "$TMPFILE" "$ERRORFILE"
944 else
945    dialog --title "$PN" --msgbox \
946    "There was an error setting up $TARGET:
947
948 $(cat "$ERRORFILE")
949
950 Exiting." 0 0
951    rm -f "$TMPFILE" "$ERRORFILE"
952    bailout 1
953 fi
954
955 }
956
957 prompt_for_swraid()
958 {
959 if dialog --stdout --title "$PN" \
960           --defaultno --yesno "Do you want to configure Software RAID?
961
962 Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
963   config_swraid_setup
964 fi
965 }
966 # }}}
967
968 # user should recheck his configuration {{{
969 # support full automatic installation:
970 checkforrun() {
971    dialog --timeout 10 --title "$PN" \
972           --yesno "Do you want to stop at this stage?
973
974 Notice: you are running ${PN} in non-interactive mode.
975 ${PN} will install Debian ${RELEASE} on ${TARGET}.
976 Last chance to quit. Timeout of 10 seconds running....
977
978 Do you want to stop now?" 0 0 2>/dev/null
979 }
980 # }}}
981
982 # format efi partition {{{
983 format_efi_partition() {
984   if [ -z "$EFI" ] ; then
985     return 0
986   fi
987
988   if ! [ -b "$EFI" ] ; then
989     eerror "Specified efi argument [$EFI] not a valid block device."
990     bailout 1
991   fi
992
993   if fsck.vfat -bn "$EFI" >/dev/null; then
994     einfo "EFI partition $EFI seems to have a FAT filesystem, not modifying."
995   else
996     einfo "EFI partition $EFI doesn't seem to be formatted, creating filesystem."
997     mkfs.fat -F32 -n "EFI" "$EFI"
998     RC=$?
999     if [ ! $RC -eq 0 ] ; then
1000       eerror "Error while creating filesystem on ${EFI}."
1001       eend 1
1002       bailout 1
1003     fi
1004   fi
1005 }
1006 # }}}
1007
1008 # check for EFI support or try to enable it {{{
1009 efi_support() {
1010   local efivars_loaded=false
1011   # this is for kernels versions before v3.10, which didn't provide efivarfs yet
1012   if modprobe efivars &>/dev/null ; then
1013     efivars_loaded=true
1014   fi
1015   # kernel versions v3.10 and newer usually provide efivarfs
1016   if modprobe efivarfs &>/dev/null ; then
1017     efivars_loaded=true
1018   fi
1019
1020   if [ -d /sys/firmware/efi ] ; then
1021     einfo "EFI support detected."
1022     return 0
1023   fi
1024
1025   if ! [ -d /sys/firmware/efi ] && [ "${efivars_loaded:-}" = "true" ] ; then
1026     einfo "EFI support detected, but system seems to be running in BIOS mode."
1027   fi
1028
1029   return 1
1030 }
1031 # }}}
1032
1033 # make sure the user is aware of the used configuration {{{
1034 checkconfiguration()
1035 {
1036
1037 if efi_support ; then
1038   if [ -z "$_opt_efi" ] ; then
1039     ewarn "EFI support detected but no --efi option given, please consider enabling it."
1040   fi
1041 else
1042   if [ -n "$_opt_efi" ] ; then
1043      eerror "EFI option used but no EFI support detected."
1044      bailout 1
1045   fi
1046 fi
1047
1048 if [ -n "$AUTOINSTALL" ] ; then
1049    if checkforrun ; then
1050       eerror "Exiting as requested"
1051       bailout 1
1052    fi
1053 elif [ -n "$INTERACTIVE" ] ; then
1054
1055    INFOTEXT="Please recheck configuration before execution:
1056    "
1057    [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
1058    Target:          $TARGET"
1059    [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
1060    Install grub:    $GRUB"
1061    [ -n "$EFI" ]    && INFOTEXT="$INFOTEXT
1062    Install efi:     $EFI"
1063    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
1064    Using release:   $RELEASE"
1065    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
1066    Using hostname:  $HOSTNAME"
1067    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
1068    Using mirror:    $MIRROR"
1069    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
1070    Using ISO:       $ISO"
1071    [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
1072    Using arch:      $ARCH"
1073    [ -n "$CONFFILES" ] && INFOTEXT="$INFOTEXT
1074    Config files:    $CONFFILES"
1075
1076    INFOTEXT="$INFOTEXT
1077
1078 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
1079
1080    dialog --title "$PN" --no-collapse \
1081           --yesno "$INFOTEXT" 0 0
1082    [ $? -eq 0 ] || bailout 0
1083
1084 else # if not running automatic installation display configuration and prompt for execution:
1085    einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
1086    echo
1087    echo "   Target:          $TARGET"
1088
1089    # do not display if MNTPOINT is the default one
1090    case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
1091
1092    if [ -n "$VIRTUAL" ] && [ "$GRUB_INSTALL" = 'yes' ] ; then
1093       echo "   Install grub:    yes"
1094       [ -n "$VMEFI" ]   && echo "   Install efi:     yes"   || echo "   Install efi:     no"
1095    else
1096      [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
1097      [ -n "$EFI" ]      && echo "   Install efi:     $EFI"  || echo "   Install efi:     no"
1098    fi
1099
1100    [ -n "$RELEASE" ]   && echo "   Using release:   $RELEASE"
1101    [ -n "$HOSTNAME" ]  && echo "   Using hostname:  $HOSTNAME"
1102    [ -n "$MIRROR" ]    && echo "   Using mirror:    $MIRROR"
1103    [ -n "$ISO" ]       && echo "   Using ISO:       $ISO"
1104    [ -n "$ARCH" ]      && echo "   Using arch:      $ARCH"
1105    [ -n "$CONFFILES" ] && echo "   Config files:    $CONFFILES"
1106    if [ -n "$VIRTUAL" ] ; then
1107       echo "   Deploying as Virtual Machine."
1108       if [ -n "$VMSIZE" ] && [ -n "$VMFILE" ]; then
1109          echo "   Using Virtual Disk file with size of ${VMSIZE}."
1110       fi
1111    fi
1112
1113    if [ ! -t 0 ] && [ -z "$ROOTPASSWORD" ] && [ -z "$NOPASSWORD" ] ; then
1114       echo
1115       echo "   You do not have a TTY allocated, your password will be shown in"
1116       echo "   plaintext on the terminal! If you are using SSH, try its -t option!"
1117    fi
1118
1119    echo
1120    echo "   Important! Continuing will delete all data from ${TARGET}!"
1121
1122    if [ -n "$FORCE" ] ; then
1123      einfo "Skip user acknowledgement as requested via --force option."
1124    else
1125      echo
1126      einfon "Is this ok for you? [y/N] "
1127      read -r a
1128      if ! [ "$a" = 'y' ] || [ "$a" = 'Y' ] ; then
1129         eerror "Exiting as requested." ; eend 1
1130         bailout 1
1131      fi
1132    fi
1133 fi
1134 }
1135 # }}}
1136
1137 # interactive mode {{{
1138 interactive_mode()
1139 {
1140   check4progs dialog || bailout 1
1141
1142   welcome_dialog
1143
1144   prompt_for_release
1145
1146   prompt_for_swraid
1147
1148   prompt_for_target
1149
1150   prompt_for_bootmanager
1151
1152   prompt_for_hostname
1153
1154   prompt_for_password
1155
1156   prompt_for_mirror
1157 }
1158
1159 # run interactive mode if we didn't get the according configuration yet
1160 if [ -z "$TARGET" ] || [ -n "$INTERACTIVE" ] ; then
1161    # only target might be unset, so make sure the INTERACTIVE flag is set as well
1162    INTERACTIVE=1
1163    interactive_mode
1164 fi
1165 # }}}
1166
1167 # architecture setup {{{
1168 if [ -n "$ARCH" ] ; then
1169    ARCHCMD="--arch $ARCH"
1170    ARCHINFO=" (${ARCH})"
1171 else
1172    ARCH="$(dpkg --print-architecture)"
1173    ARCHCMD="--arch $ARCH"
1174    ARCHINFO=" (${ARCH})"
1175 fi
1176
1177 if [ -z "${ARCH:-}" ] ; then
1178   eerror 'Architecture neither set (environment variable ARCH), nor could be automatically identified (using dpkg).'
1179   eerror 'Consider setting the --arch ... option.' ; eend 1
1180   bailout 1
1181 fi
1182 # }}}
1183
1184 # It is not possible to build amd64 on i686. {{{
1185 CURRENT_ARCH="$(uname -m)"
1186 if [ "$CURRENT_ARCH" != "x86_64" ] ; then
1187    if [ "$ARCH" = "amd64" ] ; then
1188       eerror "It is not possible to build amd64 on $CURRENT_ARCH. Consider installing and booting the 'linux-image-amd64' kernel or using '--arch i386' instead." ; eend 1
1189       bailout 1
1190    fi
1191 fi
1192 # }}}
1193
1194 # Support for generic release codenames is unavailable. {{{
1195 if [ "$RELEASE" = "stable" ] || [ "$RELEASE" = "testing" ] ; then
1196    eerror "Generic release codenames (stable, testing) are unsupported. \
1197 Please use specific codenames such as bullseye or bookworm." ; eend 1
1198    bailout 1
1199 fi
1200 # }}}
1201
1202 checkconfiguration
1203
1204 # finally make sure at least $TARGET is set [the partition for the new system] {{{
1205 if [ -n "$TARGET" ] ; then
1206    SHORT_TARGET="${TARGET##*/}"
1207 else
1208    eerror "Please adjust $CONFFILES/config or..."
1209    eerror "... use the interactive version for configuration before running ${0}" ; eend 1
1210    bailout 1
1211 fi
1212 # }}}
1213
1214 # stages setup {{{
1215 if [ -z "$STAGES" ] ; then
1216    STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
1217    [ -d "$STAGES" ] || mkdir -p "$STAGES"
1218 fi
1219
1220 if [ -r "$STAGES"/grml-debootstrap ] ; then
1221    if grep -q 'done' "${STAGES}/grml-debootstrap" ; then
1222       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
1223       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
1224    fi
1225 fi
1226 # }}}
1227
1228 # partition handling {{{
1229 PARTITION=''
1230 DIRECTORY=''
1231
1232 set_target_directory(){
1233     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
1234     DIRECTORY=1
1235     MNTPOINT="$TARGET"
1236     MKFS=''
1237     TUNE2FS=''
1238     FSCK=''
1239     # make sure we normalise the path to an absolute directory name so something like:
1240     #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
1241     # works
1242     TARGET="$(readlink -f "$TARGET")"
1243 }
1244
1245 if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
1246     PARTITION=1
1247 else
1248     # $TARGET was not detected as block device, but we do not want to create target directory in /dev/
1249     if [[ $TARGET == "/dev/"* ]]; then
1250       eerror "Error: Will not create target directory $TARGET in /dev."
1251       eerror "  Please check the partition(s) of the blockdevice."; eend 1
1252       bailout 1
1253     fi
1254     set_target_directory
1255 fi
1256 # }}}
1257
1258 # make sure we have the right syntax when using an iso image {{{
1259 if [ -n "$ISO" ] ; then
1260    case $ISO in
1261       file*) # do nothing
1262       ;;
1263       *)
1264       ISO=file:$ISO
1265       ;;
1266    esac
1267 fi
1268 ISODIR=${ISO##file:}
1269 ISODIR=${ISODIR%%/}
1270 # }}}
1271
1272 # Debian ISOs do not contain signed Release files {{{
1273 if [ -n "$ISO" ] ; then
1274     DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
1275 fi
1276 # }}}
1277
1278 # create filesystem {{{
1279 mkfs() {
1280   if [ -n "$DIRECTORY" ] ; then
1281      einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
1282      return 0
1283   fi
1284
1285   if grep -q "$TARGET" /proc/mounts ; then
1286     eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)" ; eend 1
1287     bailout 1
1288   fi
1289
1290   # mkfs.ext* might prompt with "/dev/sdX# contains a ext* file system
1291   # created on ... Proceed anyway? (y,n)" which we want to skip in force mode
1292   if [ -n "$MKFS" ] && [ -n "$FORCE" ] ; then
1293     case "$MKFS" in
1294       mkfs.ext*)
1295         einfo "Enabling force option (-F) for mkfs.ext* tool as requested via --force switch."
1296         MKFS_OPTS="$MKFS_OPTS -F"
1297         ;;
1298     esac
1299   fi
1300
1301   # starting with e2fsprogs 1.43~WIP.2015.05.18-1 mkfs.ext4 enables the metadata_csum feature
1302   # by default, which requires a recent version of tune2fs on the target system then,
1303   # so disable this feature for older Debian releases where it's known to be unsupported
1304   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1305     case "$RELEASE" in
1306       lenny|squeeze|wheezy|jessie)
1307         # assume a more recent version if we can't identify the version via dpkg-query
1308         local e2fsprogs_version
1309         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.44)"
1310         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43~WIP.2015.05.18-1' ; then
1311           einfo "Disabling metadata_csum feature for $MKFS as $RELEASE doesn't support it."
1312           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum"
1313         fi
1314         ;;
1315     esac
1316   fi
1317
1318   # starting with e2fsprogs v1.47.0 mkfs.ext4 enables the metadata_csum_seed feature
1319   # by default, which requires Linux kernel >=4.4, e2fsprogs >=1.43, according GRUB etc.
1320   # Disable this feature for Debian releases older than bookworm
1321   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1322     case "$RELEASE" in
1323       lenny|squeeze|wheezy|jessie|stretch|buster|bullseye)
1324         local e2fsprogs_version
1325         # assume a more recent version if we can't identify the version via dpkg-query
1326         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.47)"
1327         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43' ; then
1328           einfo "Disabling metadata_csum_seed feature for $MKFS as $RELEASE doesn't support it."
1329           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum_seed"
1330         fi
1331         ;;
1332     esac
1333   fi
1334
1335   if [ -n "$MKFS" ] ; then
1336
1337     if [ -n "${ARM_EFI_TARGET}" ] ; then
1338       einfo "Running mkfs.fat $MKFS_OPTS on $ARM_EFI_TARGET"
1339       mkfs.fat -n "EFI" "$ARM_EFI_TARGET"
1340       eend $?
1341
1342       MKFS_OPTS="$MKFS_OPTS -L LINUX"
1343     fi
1344
1345     einfo "Running $MKFS $MKFS_OPTS on $TARGET"
1346     # shellcheck disable=SC2086
1347     "$MKFS" $MKFS_OPTS "$TARGET" ; RC=$?
1348
1349     if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1350       if ! echo "$MKFS" | grep -q "mkfs.ext" ; then
1351         eerror "Not changing disk uuid for $TARGET because $MKFS doesn't seem to match for ext{2,3,4} file system"
1352         eend 1
1353         bailout 1
1354       else
1355         einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
1356         tune2fs "$TARGET" -U "$DISK_IDENTIFIER" </dev/null
1357         eend $?
1358       fi
1359     fi
1360
1361     if [ -n "$VIRTUAL" ] && [ -n "$EFI_TARGET" ]; then
1362       einfo "Creating FAT filesystem on $EFI_TARGET"
1363       mkfs.fat -F32 -n "EFI" "$EFI_TARGET"
1364       eend $?
1365     fi
1366
1367     # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
1368     # will fail to detect the uuid in the chroot
1369     if [ -n "$VIRTUAL" ] ; then
1370       einfo "Virtual environment doesn't require blockdev --rereadpt, skipping therefore"
1371     elif echo "$TARGET" | grep -q "/dev/md" ; then
1372       blockdev --rereadpt "${TARGET}"
1373     else
1374       # if we deploy to /dev/sdX# then let's see if /dev/sdX exists
1375       local main_device="${TARGET%%[0-9]*}"
1376       # sanity check to not try to e.g. access /dev/loop if we get /dev/loop0
1377       if [ -f "/sys/block/$(basename "${main_device}")/$(basename "${TARGET}")/dev" ] ; then
1378         blockdev --rereadpt "$main_device"
1379       else
1380         einfo "No underlying block device for $TARGET identified, skipping blockdev --rereadpt."
1381       fi
1382     fi
1383     # give the system 2 seconds, otherwise we might run into
1384     # race conditions :-/
1385     sleep 2
1386
1387     eend $RC
1388   fi
1389 }
1390 # }}}
1391
1392 # retrieve ID_FS_UUID {{{
1393 identify_target_uuid() {
1394   local device="$1"
1395
1396   if ! [ -b "$device" ] ; then
1397     return 1
1398   fi
1399
1400   eval "$(blkid -o udev "$1" 2>/dev/null)"
1401
1402   if [ -n "$ID_FS_UUID" ] ; then
1403     echo "$ID_FS_UUID"
1404   else
1405     return 1
1406   fi
1407 }
1408 # }}}
1409
1410 # identify TARGET_UUID {{{
1411 mountpoint_to_blockdevice() {
1412   TARGET_UUID=''
1413
1414   TARGET_UUID=$(identify_target_uuid "$TARGET" 2>/dev/null || true)
1415   if [ -n "$TARGET_UUID" ] ; then
1416     einfo "Identified UUID $TARGET_UUID for $TARGET"
1417     return 0
1418   fi
1419
1420   # $TARGET might be a mountpoint and not a blockdevice, search for according entry
1421   for file in /sys/block/*/*/dev ; do
1422     if grep -q "^$(mountpoint -d "${TARGET}")$" "$file" ; then
1423       local dev
1424       dev="${file%/dev}"
1425       dev="/dev/${dev##*/}"
1426       TARGET_UUID=$(identify_target_uuid "$dev" 2>/dev/null || true)
1427
1428       if [ -n "$TARGET_UUID" ] ; then
1429         einfo "Identified UUID $TARGET_UUID for $TARGET (via $file)"
1430         return 0
1431       fi
1432     fi
1433   done
1434 }
1435 # }}}
1436
1437 # modify filesystem settings {{{
1438 tunefs() {
1439   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
1440      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
1441      $TUNE2FS "$TARGET" </dev/null
1442      eend $?
1443   fi
1444 }
1445 # }}}
1446
1447 # mount the new partition or if it's a directory do nothing at all {{{
1448 mount_target() {
1449   if [ -n "$DIRECTORY" ] ; then
1450      einfo "Running grml-debootstrap on a directory, nothing to mount."
1451   else
1452      if grep -q "$TARGET" /proc/mounts ; then
1453         ewarn "$TARGET already mounted, continuing anyway."
1454      else
1455        if ! [ -d "${MNTPOINT}" ] ; then
1456           [ -n "$VIRTUAL" ] || mkdir -p "${MNTPOINT}"
1457        fi
1458        einfo "Mounting $TARGET to $MNTPOINT"
1459        mkdir -p "$MNTPOINT"
1460        mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
1461        eend $?
1462      fi
1463   fi
1464   if [ -n "$ISODIR" ] ; then
1465      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
1466      mkdir -p "$MNTPOINT/$ISODIR"
1467      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
1468      eend $?
1469   fi
1470 }
1471 # }}}
1472
1473 # prepare VM image for usage with debootstrap {{{
1474 prepare_vm() {
1475   if [ -z "$VIRTUAL" ] ; then
1476      return 0 # be quiet by intention
1477   fi
1478
1479   if [ -b "$TARGET" ] && [ -n "$VMFILE" ] ; then
1480      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
1481      eend 1
1482      bailout 1
1483   fi
1484   if [ ! -b "$TARGET" ] && [ -z "$VMFILE" ] ; then
1485      eerror "Error: specified virtual disk target ($TARGET) does not exist yet."
1486      eend 1
1487      bailout 1
1488   fi
1489
1490   # make sure loop module is present and a usable loop device exists
1491   modprobe -q loop
1492   if ! losetup -f >/dev/null 2>&1; then
1493     eerror "Error finding usable loop device" ; eend 1
1494     bailout 1
1495   fi
1496
1497   # if dm-mod isn't available then kpartx will fail with
1498   # "Is device-mapper driver missing from kernel? [...]"
1499   modprobe -q dm-mod
1500   if ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
1501     eerror "Device-mapper support missing in kernel." ; eend 1
1502     bailout 1
1503   fi
1504
1505   ORIG_TARGET="$TARGET" # store for later reuse
1506
1507   if [ -n "$VMFILE" ]; then
1508     qemu-img create -f raw "${TARGET}" "${VMSIZE}"
1509   fi
1510   if [ -n "$VMEFI" ]; then
1511     parted -s "${TARGET}" 'mklabel gpt'
1512     parted -s "${TARGET}" 'mkpart ESP fat32 1MiB 101MiB'
1513     parted -s "${TARGET}" 'set 1 boot on'
1514     parted -s "${TARGET}" 'mkpart bios_grub 101MiB 102MiB'
1515     parted -s "${TARGET}" 'set 2 bios_grub on'
1516     parted -s "${TARGET}" 'mkpart primary ext4 102MiB 100%'
1517
1518   else
1519     # arm64 support largely only exists for GPT
1520     if [ "$ARCH" = 'arm64' ]; then
1521       einfo "Setting up GPT partitions for arm64"
1522       parted -s "${TARGET}" 'mklabel gpt'
1523       parted -s "${TARGET}" 'mkpart EFI fat32 1MiB 10MiB'
1524       parted -s "${TARGET}" 'set 1 boot on'
1525       parted -s "${TARGET}" 'mkpart LINUX ext4 10MiB 100%'
1526     else
1527       parted -s "${TARGET}" 'mklabel msdos'
1528       if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1529         einfo "Adjusting disk signature to a fixed (non-random) value"
1530         MBRTMPFILE=$(mktemp)
1531         dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
1532         echo -en "\\x41\\x41\\x41\\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
1533         dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
1534         eend $?
1535       fi
1536       parted -s "${TARGET}" 'mkpart primary ext4 4MiB 100%'
1537       parted -s "${TARGET}" 'set 1 boot on'
1538     fi
1539   fi
1540
1541   DEVINFO=$(kpartx -asv "$TARGET") # e.g. 'add map loop0p1 (254:5): 0 20477 linear 7:0 3' - will be multi-line for arm64
1542   if [ -z "${DEVINFO}" ] ; then
1543     eerror "Error setting up loopback device." ; eend 1
1544     bailout 1
1545   fi
1546
1547   # if we're building for arm64, we operate on the first line of $DEVINFO which is the EFI partition
1548   if [ "$ARCH" = 'arm64' ]; then
1549     LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1550     LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1551     LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1552     export ARM_EFI_TARGET="/dev/mapper/$LOOP_PART"
1553     DEVINFO=${DEVINFO##*$'\n'} # now set $DEVINFO to the last line which is the OS partition
1554   fi
1555
1556   # hopefully this always works as expected
1557   LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1558   LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1559   if [ -n "$VMEFI" ]; then
1560     export EFI_TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop0p1'
1561     LOOP_PART="${LOOP_PART%p1}p3"
1562   fi
1563   LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1564   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop0p1'
1565
1566   if [ -z "$TARGET" ] ; then
1567      eerror "Error: target could not be set to according /dev/mapper/* device." ; eend 1
1568      bailout 1
1569   fi
1570 }
1571 # }}}
1572
1573 # make VM image bootable {{{
1574 grub_install() {
1575   if [ -z "${VIRTUAL}" ] ; then
1576      return 0
1577   fi
1578   if [ "${GRUB_INSTALL}" != "yes" ] ; then
1579     einfo "Not installing GRUB as requested via \$GRUB_INSTALL=$GRUB_INSTALL"
1580     return 0
1581   fi
1582
1583   if ! mount "${TARGET}" "${MNTPOINT}" ; then
1584     eerror "Error: Mounting ${TARGET} failed, can not continue." ; eend 1
1585     bailout 1
1586   fi
1587
1588   if [ -n "${ARM_EFI_TARGET}" ]; then
1589     mkdir -p "${MNTPOINT}/boot/efi"
1590     if ! mount "${ARM_EFI_TARGET}" "${MNTPOINT}/boot/efi" ; then
1591       eerror "Error: Mounting ${ARM_EFI_TARGET} failed, can not continue." ; eend 1
1592       bailout 1
1593     fi
1594   fi
1595
1596   mount -t proc none "${MNTPOINT}"/proc
1597   mount -t sysfs none "${MNTPOINT}"/sys
1598   mount -t devtmpfs udev "${MNTPOINT}"/dev
1599   mount -t devpts devpts "${MNTPOINT}"/dev/pts
1600
1601   if [ -n "$ARM_EFI_TARGET" ]; then
1602     einfo "Installing Grub as bootloader into EFI."
1603
1604     chroot "${MNTPOINT}" grub-install --target=arm64-efi --efi-directory=/boot/efi --bootloader-id=debian --recheck --no-nvram --removable
1605   # Has chroot-script installed GRUB to MBR using grub-install (successfully), already?
1606   # chroot-script skips installation for unset ${GRUB}
1607   elif [[ -z "${GRUB}" ]] || ! dd if="${GRUB}" bs=512 count=1 2>/dev/null | cat -v | grep -Fq GRUB; then
1608     einfo "Installing Grub as bootloader."
1609
1610     if ! chroot "${MNTPOINT}" dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
1611       echo "Notice: grub-pc package not present yet, installing it therefore."
1612       # shellcheck disable=SC2086
1613       DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-pc
1614     fi
1615
1616     mkdir -p "${MNTPOINT}/boot/grub"
1617     if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
1618       eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader." ; eend 1
1619       bailout 1
1620     fi
1621     cp -a "${MNTPOINT}"/usr/lib/grub/i386-pc "${MNTPOINT}/boot/grub/"
1622
1623     if [ -n "$VMEFI" ]; then
1624
1625       mkdir -p "${MNTPOINT}"/boot/efi
1626       mount -t vfat "${EFI_TARGET}" "${MNTPOINT}"/boot/efi
1627
1628       if ! chroot "${MNTPOINT}" dpkg --list shim-signed 2>/dev/null | grep -q '^ii' ; then
1629         echo "Notice: shim-signed package not present yet, installing it therefore."
1630         # shellcheck disable=SC2086
1631         DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS shim-signed
1632       fi
1633
1634       if [ "$(dpkg --print-architecture)" = "arm64" ]; then
1635         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-arm64-signed 2>/dev/null | grep -q '^ii' ; then
1636           echo "Notice: grub-efi-arm64-signed package not present yet, installing it therefore."
1637           # shellcheck disable=SC2086
1638           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-arm64-bin grub-efi-arm64-signed
1639         fi
1640         chroot "$MNTPOINT" grub-install --target=arm64-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1641       elif [ "$(dpkg --print-architecture)" = "i386" ]; then
1642         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-ia32-signed 2>/dev/null | grep -q '^ii' ; then
1643           echo "Notice: grub-efi-ia32-signed package not present yet, installing it therefore."
1644           # shellcheck disable=SC2086
1645           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-ia32-bin grub-efi-ia32-signed
1646         fi
1647         chroot "$MNTPOINT" grub-install --target=i386-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1648         chroot "$MNTPOINT" grub-install --target=i386-pc "/dev/$LOOP_DISK"
1649       else
1650         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-amd64-signed 2>/dev/null | grep -q '^ii' ; then
1651           echo "Notice: grub-efi-amd64-signed package not present yet, installing it therefore."
1652           # shellcheck disable=SC2086
1653           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-amd64-bin grub-efi-amd64-signed
1654         fi
1655         chroot "$MNTPOINT" grub-install --target=x86_64-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1656         chroot "$MNTPOINT" grub-install --target=i386-pc "/dev/$LOOP_DISK"
1657       fi
1658     else
1659       dd if="${MNTPOINT}/usr/lib/grub/i386-pc/boot.img" of="${ORIG_TARGET}" conv=notrunc bs=440 count=1
1660       case "${_opt_filesystem}" in
1661         f2fs)
1662           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos f2fs
1663           ;;
1664         xfs)
1665           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos xfs
1666           ;;
1667         # NOTE - we might need to distinguish between further filesystems
1668         *)
1669           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
1670           ;;
1671       esac
1672
1673       dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=1
1674       rm -f "${MNTPOINT}/tmp/core.img"
1675     fi
1676   fi
1677
1678   # workaround for Debian bug #918590 with lvm + udev:
1679   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1680   if [ -d /run/udev ] ; then
1681     einfo "Setting up bind-mount /run/udev"
1682     mkdir -p "${MNTPOINT}"/run/udev
1683     mount --bind /run/udev "${MNTPOINT}"/run/udev
1684     eend $?
1685   fi
1686
1687   if [ -n "${BOOT_APPEND}" ] ; then
1688     echo "Adding BOOT_APPEND configuration ['${BOOT_APPEND}'] to /etc/default/grub."
1689     sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" "${MNTPOINT}/etc/default/grub"
1690   fi
1691
1692   einfo "Updating grub configuration file."
1693   chroot "${MNTPOINT}" update-grub
1694   chroot "${MNTPOINT}" sync
1695
1696   case "$RELEASE" in
1697     jessie)
1698       einfo "Applying workaround for GRUB font path bug in jessie (Debian #787685)."
1699       mkdir -p "${MNTPOINT}/boot/grub/fonts/"
1700       cp "${MNTPOINT}/usr/share/grub/unicode.pf2" "${MNTPOINT}/boot/grub/fonts/"
1701       ;;
1702   esac
1703
1704   if grep -q '^GRUB_DISABLE_LINUX_UUID=.*true' "${MNTPOINT}"/etc/default/grub 2>/dev/null ; then
1705     ewarn "GRUB_DISABLE_LINUX_UUID is set to true in /etc/default/grub, not adjusting root= in grub.cfg."
1706     ewarn "Please note that your system might NOT be able to properly boot."
1707   elif [ -z "$ARM_EFI_TARGET" ]; then
1708     einfo "Adjusting grub.cfg for successful boot sequence."
1709     sed -i "s;root=[^ ]\\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
1710   fi
1711
1712   # workaround for Debian bug #918590 with lvm + udev:
1713   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1714   if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
1715     einfo "Unmounting bind-mount /run/udev"
1716     umount "${MNTPOINT}"/run/udev
1717     eend $?
1718   fi
1719
1720   umount "${MNTPOINT}"/proc
1721   umount "${MNTPOINT}"/sys
1722   umount "${MNTPOINT}"/dev/pts
1723   try_umount 3 "${MNTPOINT}"/dev
1724
1725   if [ -n "$VMEFI" ]; then
1726     umount "${MNTPOINT}"/boot/efi
1727   fi
1728
1729 }
1730 # }}}
1731
1732 # unmount VM image {{{
1733 umount_target() {
1734   if [ -z "${VIRTUAL}" ] ; then
1735      return 0
1736   fi
1737
1738   if [ -n "${ARM_EFI_TARGET}" ]; then
1739     umount "${MNTPOINT}/boot/efi"
1740   fi
1741
1742   umount "${MNTPOINT}"
1743   kpartx -d "${ORIG_TARGET}" >/dev/null
1744   # Workaround for a bug in kpartx which doesn't clean up properly,
1745   # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
1746   if dmsetup ls | grep -q "^${LOOP_PART} "; then
1747     kpartx -d "/dev/${LOOP_DISK}" >/dev/null
1748   fi
1749 }
1750 # }}}
1751
1752 # install main chroot {{{
1753 debootstrap_system() {
1754   if [ "$_opt_nodebootstrap" ]; then
1755      einfo "Skipping debootstrap as requested."
1756      return
1757   fi
1758
1759   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
1760     :
1761   else
1762     eerror "Error: $MNTPOINT not mounted, can not continue."
1763     eend 1 ; exit 1
1764   fi
1765
1766   if [ -n "$ISO" ] ; then
1767     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
1768     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
1769     # shellcheck disable=SC2086
1770     "$DEBOOTSTRAP" $ARCHCMD $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$ISO"
1771     RC=$?
1772   else
1773     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
1774     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
1775     # shellcheck disable=SC2086
1776     "$DEBOOTSTRAP" $ARCHCMD $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$MIRROR"
1777     RC=$?
1778   fi
1779
1780   if [ $RC -ne 0 ] ; then
1781     if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
1782       [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
1783       einfo "Presenting last ten lines of debootstrap.log:"
1784       tail -10 "${MNTPOINT}"/debootstrap/debootstrap.log
1785       einfo "End of debootstrap.log"
1786     fi
1787   fi
1788
1789   eend $RC
1790 }
1791 # }}}
1792
1793 # prepare chroot via chroot-script {{{
1794 preparechroot() {
1795   einfo "Preparing chroot system"
1796
1797   # provide variables to chroot system
1798   CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
1799   touch "$CHROOT_VARIABLES"
1800   chmod 600 "$CHROOT_VARIABLES" # make sure nobody except root can read it
1801   echo "# Configuration of ${PN}"                                                                                   > "$CHROOT_VARIABLES"
1802   # Resorting to sed(1) for escaping since "VAR='${VAR//\'/\'\\\'\'}'" does not work with all versions of Bash,
1803   #   e.g. not with 4.2.37(1)-release (a.k.a 4.2+dfsg-0.1+deb7u3) of Debian wheezy
1804   [ -n "$ARCH" ]                && echo "ARCH='$(sed "s,','\\\\'',g" <<<"${ARCH}")'"                               >> "$CHROOT_VARIABLES"
1805   [ -n "$BACKPORTREPOS" ]       && echo "BACKPORTREPOS='$(sed "s,','\\\\'',g" <<<"${BACKPORTREPOS}")'"             >> "$CHROOT_VARIABLES"
1806   [ -n "$BOOT_APPEND" ]         && echo "BOOT_APPEND='$(sed "s,','\\\\'',g" <<<"${BOOT_APPEND}")'"                 >> "$CHROOT_VARIABLES"
1807   [ -n "$CHROOT_SCRIPTS" ]      && echo "CHROOT_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${CHROOT_SCRIPTS}")'"           >> "$CHROOT_VARIABLES"
1808   [ -n "$COMPONENTS" ]          && echo "COMPONENTS='$(sed "s,','\\\\'',g" <<<"${COMPONENTS}")'"                   >> "$CHROOT_VARIABLES"
1809   [ -n "$CONFFILES" ]           && echo "CONFFILES='$(sed "s,','\\\\'',g" <<<"${CONFFILES}")'"                     >> "$CHROOT_VARIABLES"
1810   [ -n "$DEBCONF" ]             && echo "DEBCONF='$(sed "s,','\\\\'',g" <<<"${DEBCONF}")'"                         >> "$CHROOT_VARIABLES"
1811   [ -n "$DEBIAN_FRONTEND" ]     && echo "DEBIAN_FRONTEND='$(sed "s,','\\\\'',g" <<<"${DEBIAN_FRONTEND}")'"         >> "$CHROOT_VARIABLES"
1812   [ -n "$DEBOOTSTRAP" ]         && echo "DEBOOTSTRAP='$(sed "s,','\\\\'',g" <<<"${DEBOOTSTRAP}")'"                 >> "$CHROOT_VARIABLES"
1813   [ -n "$DEFAULT_LOCALES" ]     && echo "DEFAULT_LOCALES='$(sed "s,','\\\\'',g" <<<"${DEFAULT_LOCALES}")'"         >> "$CHROOT_VARIABLES"
1814   [ -n "$DEFAULT_LANGUAGE" ]    && echo "DEFAULT_LANGUAGE='$(sed "s,','\\\\'',g" <<<"${DEFAULT_LANGUAGE}")'"       >> "$CHROOT_VARIABLES"
1815   [ -n "$EXTRAPACKAGES" ]       && echo "EXTRAPACKAGES='$(sed "s,','\\\\'',g" <<<"${EXTRAPACKAGES}")'"             >> "$CHROOT_VARIABLES"
1816   [ -n "$EFI" ]                 && echo "EFI='$(sed "s,','\\\\'',g" <<<"${EFI}")'"                                 >> "$CHROOT_VARIABLES"
1817   [ -n "$FALLBACK_MIRROR" ]     && echo "FALLBACK_MIRROR='$(sed "s,','\\\\'',g" <<<"${FALLBACK_MIRROR}")'"         >> "$CHROOT_VARIABLES"
1818   [ -n "$FILESYSTEM" ]          && echo "FILESYSTEM='$(sed "s,','\\\\'',g" <<<"${FILESYSTEM}")'"                   >> "$CHROOT_VARIABLES"
1819   [ -n "$FORCE" ]               && echo "FORCE='$(sed "s,','\\\\'',g" <<<"${FORCE}")'"                             >> "$CHROOT_VARIABLES"
1820   [ -n "$GRMLREPOS" ]           && echo "GRMLREPOS='$(sed "s,','\\\\'',g" <<<"${GRMLREPOS}")'"                     >> "$CHROOT_VARIABLES"
1821   [ -n "$GRUB" ]                && echo "GRUB='$(sed "s,','\\\\'',g" <<<"${GRUB}")'"                               >> "$CHROOT_VARIABLES"
1822   [ -n "$HOSTNAME" ]            && echo "HOSTNAME='$(sed "s,','\\\\'',g" <<<"${HOSTNAME}")'"                       >> "$CHROOT_VARIABLES"
1823   [ -n "$INITRD" ]              && echo "INITRD='$(sed "s,','\\\\'',g" <<<"${INITRD}")'"                           >> "$CHROOT_VARIABLES"
1824   [ -n "$INITRD_GENERATOR" ]    && echo "INITRD_GENERATOR='$(sed "s,','\\\\'',g" <<<"${INITRD_GENERATOR}")'"       >> "$CHROOT_VARIABLES"
1825   [ -n "$INITRD_GENERATOR_OPTS" ] && echo "INITRD_GENERATOR_OPTS='$(sed "s,','\\\\'',g" <<<"${INITRD_GENERATOR_OPTS}")'" >> "$CHROOT_VARIABLES"
1826   [ -n "$INSTALL_NOTES" ]       && echo "INSTALL_NOTES='$(sed "s,','\\\\'',g" <<<"${INSTALL_NOTES}")'"             >> "$CHROOT_VARIABLES"
1827   [ -n "$ISODIR" ]              && echo "ISODIR='$(sed "s,','\\\\'',g" <<<"${ISO}")'"                              >> "$CHROOT_VARIABLES"
1828   [ -n "$ISO" ]                 && echo "ISO='$(sed "s,','\\\\'',g" <<<"${ISO}")'"                                 >> "$CHROOT_VARIABLES"
1829   [ -n "$KEEP_SRC_LIST" ]       && echo "KEEP_SRC_LIST='$(sed "s,','\\\\'',g" <<<"${KEEP_SRC_LIST}")'"             >> "$CHROOT_VARIABLES"
1830   [ -n "$LOCALES" ]             && echo "LOCALES='$(sed "s,','\\\\'',g" <<<"${LOCALES}")'"                         >> "$CHROOT_VARIABLES"
1831   [ -n "$MIRROR" ]              && echo "MIRROR='$(sed "s,','\\\\'',g" <<<"${MIRROR}")'"                           >> "$CHROOT_VARIABLES"
1832   [ -n "$MKFS" ]                && echo "MKFS='$(sed "s,','\\\\'',g" <<<"${MKFS}")'"                               >> "$CHROOT_VARIABLES"
1833   [ -n "$NOPASSWORD" ]          && echo "NOPASSWORD=\"true\""                                                      >> "$CHROOT_VARIABLES"
1834   [ -n "$NOKERNEL" ]            && echo "NOKERNEL=\"true\""                                                        >> "$CHROOT_VARIABLES"
1835   [ -n "$PACKAGES" ]            && echo "PACKAGES='$(sed "s,','\\\\'',g" <<<"${PACKAGES}")'"                       >> "$CHROOT_VARIABLES"
1836   [ -n "$POST_SCRIPTS" ]        && echo "POST_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${POST_SCRIPTS}")'"               >> "$CHROOT_VARIABLES"
1837   [ -n "$PRE_SCRIPTS" ]         && echo "PRE_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${PRE_SCRIPTS}")'"                 >> "$CHROOT_VARIABLES"
1838   [ -n "$RECONFIGURE" ]         && echo "RECONFIGURE='$(sed "s,','\\\\'',g" <<<"${RECONFIGURE}")'"                 >> "$CHROOT_VARIABLES"
1839   [ -n "$RELEASE" ]             && echo "RELEASE='$(sed "s,','\\\\'',g" <<<"${RELEASE}")'"                         >> "$CHROOT_VARIABLES"
1840   [ -n "$RM_APTCACHE" ]         && echo "RM_APTCACHE='$(sed "s,','\\\\'',g" <<<"${RM_APTCACHE}")'"                 >> "$CHROOT_VARIABLES"
1841   [ -n "$ROOTPASSWORD" ]        && echo "ROOTPASSWORD='$(sed "s,','\\\\'',g" <<<"${ROOTPASSWORD}")'"               >> "$CHROOT_VARIABLES"
1842   [ -n "$SCRIPTS" ]             && echo "SCRIPTS='$(sed "s,','\\\\'',g" <<<"${SCRIPTS}")'"                         >> "$CHROOT_VARIABLES"
1843   [ -n "$SECURE" ]              && echo "SECURE='$(sed "s,','\\\\'',g" <<<"${SECURE}")'"                           >> "$CHROOT_VARIABLES"
1844   [ -n "$SELECTED_PARTITIONS" ] && echo "SELECTED_PARTITIONS='$(sed "s,','\\\\'',g" <<<"${SELECTED_PARTITIONS}")'" >> "$CHROOT_VARIABLES"
1845   [ -n "$TARGET" ]              && echo "TARGET='$(sed "s,','\\\\'',g" <<<"${TARGET}")'"                           >> "$CHROOT_VARIABLES"
1846   [ -n "$UPGRADE_SYSTEM" ]      && echo "UPGRADE_SYSTEM='$(sed "s,','\\\\'',g" <<<"${UPGRADE_SYSTEM}")'"           >> "$CHROOT_VARIABLES"
1847   [ -n "$TARGET_UUID" ]         && echo "TARGET_UUID='$(sed "s,','\\\\'',g" <<<"${TARGET_UUID}")'"                 >> "$CHROOT_VARIABLES"
1848   [ -n "$TIMEZONE" ]            && echo "TIMEZONE='$(sed "s,','\\\\'',g" <<<"${TIMEZONE}")'"                       >> "$CHROOT_VARIABLES"
1849   [ -n "$TUNE2FS" ]             && echo "TUNE2FS='$(sed "s,','\\\\'',g" <<<"${TUNE2FS}")'"                         >> "$CHROOT_VARIABLES"
1850   [ -n "$VMSIZE" ]              && echo "VMSIZE='$(sed "s,','\\\\'',g" <<<"${VMSIZE}")'"                           >> "$CHROOT_VARIABLES"
1851
1852   cp $VERBOSE "${CONFFILES}"/chroot-script "${MNTPOINT}"/bin/chroot-script
1853   chmod 755 "${MNTPOINT}"/bin/chroot-script
1854   [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
1855
1856   # make sure we have our files for later use via chroot-script
1857   cp $VERBOSE "${CONFFILES}/config"           "${MNTPOINT}"/etc/debootstrap/
1858   # make sure we adjust the configuration variables accordingly:
1859   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" "${MNTPOINT}"/etc/debootstrap/config
1860   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    "${MNTPOINT}"/etc/debootstrap/config
1861   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          "${MNTPOINT}"/etc/debootstrap/config
1862
1863   # install notes:
1864   if [ -n "$INSTALL_NOTES" ] ; then
1865      [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" "${MNTPOINT}"/etc/debootstrap/
1866   fi
1867
1868   # package selection:
1869   if [ "$PACKAGES" = 'yes' ] ; then
1870     PACKAGES_FILE="packages"
1871
1872     if [ "$ARCH" = 'arm64' ]; then
1873       PACKAGES_FILE="packages-arm64"
1874     fi
1875
1876     cp $VERBOSE "${_opt_packages:-$CONFFILES/$PACKAGES_FILE}" \
1877       "${MNTPOINT}/etc/debootstrap/${PACKAGES_FILE}"
1878   fi
1879
1880   # debconf preseeding:
1881   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
1882   [ -f "${_opt_debconf}" ] && [ "$DEBCONF" = 'yes' ] && \
1883     cp $VERBOSE "${_opt_debconf}" "${MNTPOINT}"/etc/debootstrap/debconf-selections
1884
1885   # copy scripts that should be executed inside the chroot:
1886   _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
1887   [ -d "$_opt_chroot_scripts" ] && [ "$CHROOT_SCRIPTS" = 'yes' ] && {
1888     mkdir -p "${MNTPOINT}"/etc/debootstrap/chroot-scripts
1889     cp -a $VERBOSE "${_opt_chroot_scripts}"/* "${MNTPOINT}"/etc/debootstrap/chroot-scripts/
1890   }
1891
1892   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
1893   cp $VERBOSE "${CHROOT_VARIABLES}" "${MNTPOINT}"/etc/debootstrap/variables
1894
1895   cp $VERBOSE -a -L "${CONFFILES}"/extrapackages/ "${MNTPOINT}"/etc/debootstrap/
1896
1897   # make sure we can access network [relevant for cdebootstrap/mmdebstrap]
1898   [ -f "${MNTPOINT}"/etc/resolv.conf ] || cp $VERBOSE /etc/resolv.conf "${MNTPOINT}"/etc/resolv.conf
1899
1900   # setup default locales
1901   [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
1902
1903   # MAKEDEV is just a forking bomb crap, let's do it on our own instead :)
1904   ( cd "${MNTPOINT}"/dev && tar zxf /etc/debootstrap/devices.tar.gz )
1905
1906   # copy any existing files to chroot
1907   [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
1908   [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
1909   [ -d "${CONFFILES}"/etc   ] && cp $VERBOSE -a -L "${CONFFILES}"/etc/*   "${MNTPOINT}"/etc/
1910   [ -d "${CONFFILES}"/sbin  ] && cp $VERBOSE -a -L "${CONFFILES}"/sbin/*  "${MNTPOINT}"/sbin/
1911   [ -d "${CONFFILES}"/share ] && cp $VERBOSE -a -L "${CONFFILES}"/share/* "${MNTPOINT}"/share/
1912   [ -d "${CONFFILES}"/usr   ] && cp $VERBOSE -a -L "${CONFFILES}"/usr/*   "${MNTPOINT}"/usr/
1913   [ -d "${CONFFILES}"/var   ] && cp $VERBOSE -a -L "${CONFFILES}"/var/*   "${MNTPOINT}"/var/
1914
1915   # network setup
1916   DEFAULT_INTERFACES="# /etc/network/interfaces - generated by grml-debootstrap
1917
1918 # Include files from /etc/network/interfaces.d when using
1919 # ifupdown v0.7.44 or newer:
1920 #source-directory /etc/network/interfaces.d
1921
1922 auto lo
1923 iface lo inet loopback
1924
1925 allow-hotplug eth0
1926 iface eth0 inet dhcp
1927 "
1928
1929   # add dhcp setting for Predictable Network Interface Names
1930   if [ -x /bin/udevadm ]; then
1931     tmpfile=$(mktemp)
1932     for interface in /sys/class/net/*; do
1933       udevadm info --query=all --path="${interface}" > "${tmpfile}"
1934       # skip virtual devices, like bridges, vboxnet,...
1935       if grep -q 'P: /devices/virtual/net/' "${tmpfile}" ; then
1936         continue
1937       fi
1938
1939       # iterate over possible naming policies by precedence (see udev/net/link-config.c),
1940       # use and stop on first match to have same behavior as udev's link_config_apply()
1941       for property in ID_NET_NAME_FROM_DATABASE ID_NET_NAME_ONBOARD ID_NET_NAME_SLOT ID_NET_NAME_PATH ID_NET_NAME_MAC ; do
1942         if grep -q "${property}" "${tmpfile}" ; then
1943           interface=$(grep "${property}" "${tmpfile}" | sed -n -e "s/E: ${property}=\([^\$*]\)/\1/p")
1944           DEFAULT_INTERFACES="${DEFAULT_INTERFACES}
1945 allow-hotplug ${interface}
1946 iface ${interface} inet dhcp
1947 "
1948           break
1949         fi
1950       done
1951     done
1952     rm -f "${tmpfile}"
1953   fi
1954
1955   if [ -n "$NOINTERFACES" ] ; then
1956     einfo "Not installing /etc/network/interfaces as requested via --nointerfaces option"
1957   elif [ -n "$USE_DEFAULT_INTERFACES" ] ; then
1958     einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
1959     mkdir -p "${MNTPOINT}/etc/network"
1960     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1961     eend $?
1962   elif [ -n "$VIRTUAL" ] ; then
1963     einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
1964     mkdir -p "${MNTPOINT}/etc/network"
1965     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1966     eend $?
1967   elif [ -r /etc/network/interfaces ] ; then
1968     einfo "Copying /etc/network/interfaces from host to target system"
1969     mkdir -p "${MNTPOINT}/etc/network"
1970     cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
1971     eend $?
1972   else
1973     ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
1974     mkdir -p "${MNTPOINT}/etc/network"
1975     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1976     eend $?
1977   fi
1978
1979   # install config file providing some example entries
1980   if [ -r /etc/network/interfaces.examples ] && [ ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
1981     mkdir -p "${MNTPOINT}/etc/network"
1982     cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
1983   fi
1984
1985   if [ -n "${SSHCOPYID}" ] ; then
1986     AUTHORIZED_KEYS_SOURCE=${AUTHORIZED_KEYS_SOURCE:-$HOME/.ssh/authorized_keys}
1987     AUTHORIZED_KEYS_TARGET=${AUTHORIZED_KEYS_TARGET:-$MNTPOINT/root/.ssh/}
1988     if ssh-add -L >/dev/null 2>&1 ; then
1989       einfo "Use locally available public keys to authorise root login on the target system as requested via --sshcopyid option."
1990       mkdir -p "${MNTPOINT}"/root/.ssh
1991       chmod 0700 "${MNTPOINT}"/root/.ssh
1992       if ! ssh-add -L >> "${MNTPOINT}"/root/.ssh/authorized_keys ; then
1993         eerror "Error: executing 'ssh-add -L' failed."
1994         eend 1
1995         bailout 1
1996       fi
1997     elif [ -f "$AUTHORIZED_KEYS_SOURCE" ]; then
1998       einfo "copying '$AUTHORIZED_KEYS_SOURCE' to '$AUTHORIZED_KEYS_TARGET' as requested via --sshcopyid option."
1999       mkdir -p "$AUTHORIZED_KEYS_TARGET"
2000       chmod 0700 "$AUTHORIZED_KEYS_TARGET"
2001       if ! cp "$AUTHORIZED_KEYS_SOURCE" "$AUTHORIZED_KEYS_TARGET" ; then
2002         eerror "Error: copying '$AUTHORIZED_KEYS_SOURCE' to '$AUTHORIZED_KEYS_TARGET' failed"
2003         eend 1
2004         bailout 1
2005       fi
2006     else
2007       eerror "Error: Could not open a connection to your authentication agent or the agent has no identities."
2008       eend 1
2009       bailout 1
2010     fi
2011   fi
2012
2013   if [ -n "${SSHCOPYAUTH}" ] ; then
2014     AUTHORIZED_KEYS_SOURCE=${AUTHORIZED_KEYS_SOURCE:-${HOME}/.ssh/authorized_keys}
2015
2016     if ! [ -f "${AUTHORIZED_KEYS_SOURCE}" ]; then
2017       eerror "Error: could not read '${AUTHORIZED_KEYS_SOURCE}' for setting up SSH key login."
2018       eend 1
2019       bailout 1
2020     fi
2021
2022     AUTHORIZED_KEYS_TARGET="${MNTPOINT}/root/.ssh/"
2023     einfo "Copying '${AUTHORIZED_KEYS_SOURCE}' to '${AUTHORIZED_KEYS_TARGET}' as requested via --sshcopyauth option."
2024     mkdir -p "${AUTHORIZED_KEYS_TARGET}"
2025     chmod 0700 "${AUTHORIZED_KEYS_TARGET}"
2026     if ! cp "${AUTHORIZED_KEYS_SOURCE}" "${AUTHORIZED_KEYS_TARGET}" ; then
2027       eerror "Error: copying '${AUTHORIZED_KEYS_SOURCE}' to '${AUTHORIZED_KEYS_TARGET}' failed."
2028       eend 1
2029       bailout 1
2030     fi
2031   fi
2032
2033   if [ -d /run/udev ] ; then
2034     einfo "Setting up bind-mount /run/udev"
2035     mkdir -p "${MNTPOINT}"/run/udev
2036     mount --bind /run/udev "${MNTPOINT}"/run/udev
2037     eend $?
2038   fi
2039 }
2040 # }}}
2041
2042 # execute all scripts in /etc/debootstrap/pre-scripts/ {{{
2043 execute_pre_scripts() {
2044   # make sure hostname is set even before chroot-script get executed
2045   echo "$HOSTNAME" > "$MNTPOINT"/etc/hostname
2046
2047   # make sure we have $MNTPOINT available for our scripts
2048   export MNTPOINT
2049
2050   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
2051     [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="${CONFFILES}/pre-scripts/"
2052     for script in "${pre_scripts}"/* ; do
2053       if [ -x "$script" ] ; then
2054         einfo "Executing pre-script $script"
2055         "$script" ; eend $?
2056       fi
2057     done
2058   fi
2059 }
2060 # }}}
2061
2062 # execute all scripts in /etc/debootstrap/post-scripts/ {{{
2063 execute_post_scripts() {
2064   # make sure we have $MNTPOINT and HOSTNAME available for our scripts
2065   export MNTPOINT
2066   export TARGET_HOSTNAME=$HOSTNAME
2067
2068   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
2069     # legacy support for /etc/debootstrap/scripts/
2070     [ -d "$_opt_scripts" ] && post_scripts="$_opt_scripts" || post_scripts="${CONFFILES}/scripts/"
2071     ewarn "Deprecation NOTE: --scripts/SCRIPTS are deprecated, please switch to --post-scripts/POST_SCRIPTS instead."
2072   elif [ -d "$_opt_post_scripts" ] || [ "$POST_SCRIPTS" = 'yes' ] ; then
2073     [ -d "$_opt_post_scripts" ] && post_scripts="$_opt_post_scripts" || post_scripts="${CONFFILES}/post-scripts/"
2074   fi
2075
2076   if [ -n "$post_scripts" ] ; then
2077     for script in "${post_scripts}"/* ; do
2078       if [ -x "$script" ] ; then
2079         einfo "Executing post-script $script"
2080         "$script" ; eend $?
2081       fi
2082     done
2083   fi
2084 }
2085 # }}}
2086
2087 # unmount mountpoint {{{
2088 try_umount() {
2089   local tries=$1
2090   local mountpoint="$2"
2091
2092   for (( try=1; try<=tries; try++ )); do
2093     if [[ ${try} -eq ${tries} ]]; then
2094       # Last time, show errors this time
2095       umount "${mountpoint}" && return 0
2096     else
2097       # Not last time, hide errors until fatal
2098       if umount "${mountpoint}" 2>/dev/null ; then
2099         return 0
2100       else
2101         sleep 1
2102       fi
2103     fi
2104   done
2105   return 1  # Tried enough
2106 }
2107 # }}}
2108
2109 # execute chroot-script {{{
2110 chrootscript() {
2111   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
2112     mount_target
2113   fi
2114
2115   if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
2116     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
2117     eend 1
2118   else
2119     einfo "Executing chroot-script now"
2120     mount -t devtmpfs udev "${MNTPOINT}"/dev
2121     mount -t devpts devpts "${MNTPOINT}"/dev/pts
2122     if [ "$DEBUG" = "true" ] ; then
2123       chroot "$MNTPOINT" /bin/bash -x /bin/chroot-script ; RC=$?
2124     else
2125       chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
2126     fi
2127     try_umount 3 "$MNTPOINT"/dev/pts
2128     try_umount 3 "$MNTPOINT"/dev
2129     eend $RC
2130   fi
2131
2132   # finally get rid of chroot-script again, there's no good reason to
2133   # keep it on the installed system
2134   if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
2135     einfo "Removing chroot-script again"
2136     rm -f "${MNTPOINT}/bin/chroot-script"
2137     eend $?
2138   else
2139     einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
2140   fi
2141 }
2142 # }}}
2143
2144 # unmount $MNTPOINT {{{
2145 umount_chroot() {
2146
2147   # display installation notes:
2148   if [ -n "$INSTALL_NOTES" ] ; then
2149      [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
2150   fi
2151
2152   if [ -n "$ISODIR" ] ; then
2153      if grep -q "$ISODIR" /proc/mounts ; then
2154         einfo "Unmount $MNTPOINT/$ISODIR"
2155         umount "$MNTPOINT/$ISODIR"
2156         eend $?
2157      fi
2158   fi
2159
2160   if grep -q "$MNTPOINT" /proc/mounts ; then
2161     if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
2162       einfo "Unmounting bind-mount /run/udev"
2163       umount "${MNTPOINT}"/run/udev
2164       eend $?
2165     fi
2166
2167      if [ -n "$PARTITION" ] ; then
2168         einfo "Unmount $MNTPOINT"
2169         umount "$MNTPOINT"
2170         eend $?
2171      fi
2172   fi
2173 }
2174 # }}}
2175
2176 # execute filesystem check {{{
2177 fscktool() {
2178  if [ -n "$VIRTUAL" ] ; then
2179    einfo "Skipping filesystem check because we deploy a virtual machine."
2180    return 0
2181  fi
2182
2183  if [ "$FSCK" = 'yes' ] ; then
2184    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
2185    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
2186    "$FSCKTOOL" "$TARGET"
2187    eend $?
2188  fi
2189 }
2190 # }}}
2191
2192 # get rid of grml-debootstrap config files {{{
2193 remove_configs() {
2194   if [ "$REMOVE_CONFIGS" != "yes" ] ; then
2195     return 0
2196   fi
2197
2198   if ! mountpoint "${MNTPOINT}" >/dev/null 2>&1 ; then
2199     ewarn "Target ${MNTPOINT} doesn't seem to be mounted, can't remove configuration files."
2200     return 0
2201   fi
2202
2203   einfo "Removing configuration files from installed system as requested via --remove-configs / REMOVE_CONFIGS."
2204   rm -rf "${MNTPOINT}"/etc/debootstrap/
2205   eend $?
2206 }
2207 # }}}
2208
2209 # now execute all the functions {{{
2210 for i in format_efi_partition prepare_vm mkfs tunefs \
2211          mount_target mountpoint_to_blockdevice debootstrap_system \
2212          preparechroot execute_pre_scripts chrootscript execute_post_scripts \
2213          remove_configs umount_chroot grub_install umount_target fscktool ; do
2214     if stage "${i}" ; then
2215       "$i"
2216       if [ $? -eq 0 ]; then
2217         stage "${i}" 'done' && rm -f "${STAGES}/${i}"
2218       else
2219         bailout 2 "$i"
2220       fi
2221     fi
2222 done
2223
2224 cleanup
2225 # }}}
2226
2227 # end dialog of autoinstallation {{{
2228 if [ -n "$AUTOINSTALL" ] ; then
2229    if dialog --title "${PN}" --pause "Finished execution of ${PN}.
2230 Automatically rebooting in 10 seconds.
2231
2232 Choose Cancel to skip rebooting." 10 60 10 ; then
2233      noeject noprompt reboot
2234   fi
2235 else
2236    einfo "Finished execution of ${PN}. Enjoy your Debian system."
2237 fi
2238 # }}}
2239
2240 ## END OF FILE #################################################################
2241 # vim: ai tw=100 expandtab foldmethod=marker shiftwidth=2